#ifndef _ADOC_H
#define _ADOC_H


#include <sys/time.h>
#include <sys/types.h>
#include <stdio.h>


#define ADOC_MAX_LEVEL 10
#define ADOC_MIN_LEVEL 0


/* ADOC API*/

ssize_t adoc_send_file(int, FILE *, size_t *);
ssize_t  adoc_send_file_levels(int, FILE*, size_t *,unsigned int, unsigned int);
ssize_t  adoc_write(int, void *, size_t,size_t *);
ssize_t adoc_write_levels(int, void *, size_t, size_t *, unsigned int, unsigned int);
ssize_t adoc_receive_file(int, FILE *);
ssize_t  adoc_read(int, void *, size_t);
int adoc_close(int);




/***************
Error codes 
-1 is reserved for system call error with errno set
****************/
#define ADOC_ERROR_WITH_ERRNO_SET -1 /*System call error : check errno */
#define ADOC_UNKNOWN_PACKET -2 /*Unknown packet ID*/
#define ADOC_COMPRESSION_ERROR -3  /*Error while compressing or uncompressing data*/
#define ADOC_PROTOCOL_ERROR -4 /*Error in the ADOC protocol */
#define ADOC_LEVEL_ERROR -5 /*unexpected compression level*/
#define ADOC_NETWORK_ERROR -6 /*wrong size of data received*/
#define ADOC_WRITE_ERROR -7 /*wrong size of data writen by system call write*/
#define ADOC_RETVAL_ERROR -8 /*Return Value != 0*/
#define ADOC_FILE_ERROR -9 /*Error while reading file*/



#endif   /* _ADOC_H */

