#ifndef RECEPTION_H
#define RECEPTION_H

 
#define VERBOSE
#define ADOC_MAX_RECV_PACKETS (1+(2*LZF_BUFFER_SIZE)/ADOC_PACKET_SIZE)

/*This is a cell element for a chained list
that store on the reveiver data that have not been
read completely. These data can be retreived at the next 
AdOC call.

At a given moment each cell have a different socket ID*/
typedef struct _list{
    int socket; /*identification of the socket*/
    byte * buffer; /*pointer to the data*/
    size_t size; /*size of the data*/
    struct _list *next; /*pointer to the next cell*/
}list;


typedef struct{
    int socket;
    FILE *file;
    byte *store_buffer;
    size_t store_size;
    byte *data_buffer;
    ssize_t *byte_recv;
    size_t count;
    adoc_sem r_sem,w_sem;
    byte *data_window,*data_w_pointer;
    header *header_window;
    unsigned int header_r,header_w;
    int ADOC_flag; /* zero if a packet have not been received for that session*/
    int error; /*Error code 0 if no error detected, negative value otherwise*/
}ADOC_session;


void free_buffer(int socket);
void * reception_thread(void *arg);
ssize_t retreive_buffer(int socket,byte * buffer, size_t size);
int store_buffer2(int socket,byte * buffer,size_t size,byte *store_buffer,size_t store_size);
int store_buffer(int socket,byte * buffer,size_t size,ADOC_session *ADOC_global);
void * file_decompression_thread(void *arg);
void * data_decompression_thread(void *arg);
ssize_t launch_recep_threads(int socket,byte *data_buffer, size_t count,byte *s_buffer, size_t store_size,ssize_t res,size_t size);

#endif /*RECEPTION_H*/
