#include "common.h"
#include "reception.h"


ssize_t raw_recv(int socket,byte * data_buffer,size_t count,size_t data_size,int store_flag,byte ** s_buffer, size_t *store_size){

    
    if(count>=data_size){
        ssize_t res;
        res=READ(socket,data_buffer,data_size);
        return res;

    }else{
        if(count)
            READ(socket,data_buffer,count);
        if(store_flag==1){ /*store_flag==0 if an other call with store_flag==1 will happen*/
            byte *buffer;

            buffer=(byte *)malloc(sizeof(byte)*(data_size-count));
            if(buffer==NULL){
                return ADOC_ERROR_WITH_ERRNO_SET;
            }
            READ(socket,buffer,data_size-count);
            store_buffer2(socket,buffer,data_size-count,*s_buffer,*store_size);

        }else{
            byte *buffer;
            buffer=(byte *)malloc(sizeof(byte)*
                                           (data_size-count+(*store_size)));

            if(buffer==NULL){
                return ADOC_ERROR_WITH_ERRNO_SET;
            }
            if(*store_size){
                memcpy(buffer,*s_buffer,*store_size);
                free(s_buffer);
            }
            READ(socket,buffer+(*store_size),data_size-count);
            *s_buffer=buffer;
            *store_size=(*store_size)+data_size-count;
        }

        return count;
    }
}


ssize_t adoc_read_wraper(int socket,void *buffer,
                  size_t count){

    byte *s_buffer=NULL;
    size_t store_size=0;
    ssize_t res=0,ret;
    ssize_t size;
    uint32_t sval;
    size_t val;
    int8_t c;
    byte *data_buffer=(byte*)buffer;
    
    /* check if some data are in temporary buffers (not retreived from the previous call)*/
    if((size=retreive_buffer(socket,data_buffer,count))<0)
        return size;

    if(count!=0){
        if(size==count){
            return count;
        }else{
            data_buffer+=size;
            count-=size;
        }
    }
    /*We still have some data to retreive...*/



    
    /*can we do raw recv? */
    ret=READ(socket,&c,1);
    if(ret==0)
        return 0;
    if(c>=0){
        ssize_t res;
        res=raw_recv(socket,data_buffer,count,c,1,&s_buffer,&store_size)+size;

        return res;
    }
    switch (c){
        case ADOC_RAW:
            READ(socket,(byte *)&sval,4);
            val=(size_t)ntohl(sval);
            if((ret=raw_recv(socket,data_buffer,count,val,1,&s_buffer,&store_size))<0)
                return ret;
            else
                return ret+size;
        case ADOC_CMP:
            break;
        case ADOC_TEST:
            READ(socket,(byte *)&sval,4);
            val=(size_t)ntohl(sval);

            /*fprintf(stderr,"------------test\n");*/
            res=raw_recv(socket,data_buffer,count,val,0,&s_buffer,&store_size);

            
            if(res<0)
                return res;
                if(res<=count){
                    count-=res;
                    data_buffer+=res;
                }else {
                    count =0;
                }
                    
            READ(socket,&c,1);
            /*fprintf(stderr,"c=%d, cout=%ld\n",c,count);*/

            if(c>=0){
                if((ret=raw_recv(socket,data_buffer,count,c,1,&s_buffer,&store_size))<0)
                    return ret;
                else
                    return ret+res+size;
            }
                if(c==ADOC_RAW){
                    READ(socket,(byte *)&sval,4);
                    val=(size_t)ntohl(sval);
                    if((ret=raw_recv(socket,data_buffer,count,val,1,&s_buffer,&store_size))<0)
                        return ret;
                    else
                        return ret+res+size;
                }else if(c==ADOC_CMP)
                    break;
            else
                return ADOC_PROTOCOL_ERROR;
        default:
            return ADOC_PROTOCOL_ERROR;
    }
    return launch_recep_threads(socket,data_buffer,count,s_buffer,store_size,res,size);
    
}

