#include <stdlib.h>
#include "timings.h"
#include "adoc.h"
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>

#define NAME_SIZE  1024

/* Service for receiving data*/
FILE *adoc_fopen(char *nom,char *mode){
    FILE *res;
    res=fopen(nom,mode);
    if(res==NULL){
	fprintf(stderr,"Unable to open %s with mode %s!\n",nom,mode);
	exit(-1);
    }
    return res;
}


void service(int socket){
 
    char template[20];
    CLOCK_T begin,end;
    unsigned long int size;
    double time;
    FILE *pf;
    CLOCK(begin); 
    strcpy(template,"/tmp/file.adoc");
    pf=adoc_fopen(template,"w");
    printf("Writing incomming file in : %s.\n",template);
    size=adoc_receive_file(socket,pf);
    CLOCK(end);  
    time=CLOCK_DIFF(end,begin);
    printf("Receiving %lu bytes in %.2f seconds\n\n",size,time);
    fclose(pf);
}



void wait_sigchild(int sig){
    int code;
    wait(&code);
}

/*Create a socket TCP and return port number*/
int create_sock(int *port, int type){

  int desc; /*dsocket descriptor*/
  struct sockaddr_in nom; /*socket adress*/
  socklen_t longueur; /* adress length*/

  /* creating socket */

  if((desc=socket(AF_INET,type,0))==-1){
    perror("Socket creation failed.\n");
    return -2;
  }
  

  nom.sin_port=htons(*port);
  nom.sin_addr.s_addr=INADDR_ANY;
  nom.sin_family=AF_INET;

  if(bind(desc,(struct sockaddr *)&nom,sizeof(nom))){
    perror("Socket naming failed.\n");
    return -3;
  }
  
  longueur = sizeof(nom);
  if(getsockname(desc,(struct sockaddr *)&nom,&longueur)){
    perror("Getting name of the socket failed.\n");
    return -4;
  }

  *port=ntohs(nom.sin_port);
  return desc;
}

int main(int argc, char **argv){
    
  int listen_sock,service_sock;
  struct sockaddr_in adr;
  socklen_t lgadr = sizeof(struct sockaddr_in);
  char name[NAME_SIZE];
  int port=0;

  if(argc==2){
      port=atoi(argv[1]);
      printf("Trying port : %d\n",port);
  }
  if((listen_sock=create_sock(&port,SOCK_STREAM))==-1){
    fprintf(stderr,"Creation/liason de socket impossible\n");
    exit(2);
  }

  gethostname(name,NAME_SIZE);

  printf("Socket open on port %d on host %s\n",port,name);


  /*creation of the pending connection file */

  listen (listen_sock,5);

  /*Handler for SIGCHLD signal*/
    signal (SIGCHLD,wait_sigchild);

    while(1){

        lgadr=sizeof(adr);
        /* waiting for a connection*/
        service_sock=accept(listen_sock,(struct sockaddr*)&adr,&lgadr);
        if(service_sock>0){
            /* forking processus*/
            if(fork()==0){
                /* son executes service*/
                close(listen_sock);
                service(service_sock);
                exit(0);
            } else{
                /*father return to accept*/
                close(service_sock);
            }
            
        }
    }
  return 0;
}
